#ifndef _XMESHLIB_ALLRENDERER_H
#define _XMESHLIB_ALLRENDERER_H

#include "GL/glew.h"
#include <FL/Fl.h>
#include <FL/gl.h>
#include <FL/glut.h>
#include <GL/glu.h>
#include <FL/Fl_Gl_Window.h>

#include "../Math/Point2.h"
#include "../Math/Vector3.h"
#include "../Math/Quaternion.h"

namespace XMeshLib
{
	//== DEFINITION ===============================================================

	#define DOF				5.0f
	#define SELBUF_SIZE		1024

	#ifndef GL_SEPARATE_SPECULAR_COLOR
	#define GL_SEPARATE_SPECULAR_COLOR 0x81FA
	#endif

	#ifndef GL_LIGHT_MODEL_COLOR_CONTROL
	#define GL_LIGHT_MODEL_COLOR_CONTROL 0x81F8
	#endif

	#define FONT_STROKE			0
	#define FONT_BITMAP			1

	#define TEX2_HEIGHT			256
	#define TEX2_WIDTH			256
	#define TEX2_COUNT			7
	#define TEX3_HEIGHT			256
	#define TEX3_WIDTH			256
	#define TEX3_DEPTH			256
	#define TEX3_COUNT			7


	#define MATERIAL_DEFAULT	0
	#define MATERIAL_BRASS		1
	#define MATERIAL_BRONZE		2
	#define MATERIAL_CHROME		3
	#define MATERIAL_COPPER		4
	#define MATERIAL_GOLD		5
	#define MATERIAL_P_GOLD		6
	#define MATERIAL_PEWTER		7
	#define MATERIAL_SILVER		8
	#define MATERIAL_P_SILVER	9
	#define MATERIAL_EMERALD	10
	#define MATERIAL_JADE		11
	#define MATERIAL_OBSIDIAN	12
	#define MATERIAL_PEARL		13
	#define MATERIAL_RUDY		14
	#define MATERIAL_TURQUOISE	15
	#define MATERIAL_SKIN	    16
	#define MATERIAL_INDIANRED	17		
	#define MATERIAL_DODGEBLUE	18

	#define SHADING_SMOOTH		0
	#define SHADING_FLAT		1


	#define REP_SOLID			0
	#define REP_POINTSET		1

	#define PICKING_VERTEX		0
	#define PICKING_EDGE		1
	#define PICKING_FACE		2
	

	#define POLYGON_FILL		0
	#define POLYGON_LINE		1
	#define POLYGON_POINT		2

	const float COLORTAB[12][3]= {{255.0f/255.0f,   0.0f/255.0f,   0.0f/255.0f},
								{255.0f/255.0f, 128.0f/255.0f,  64.0f/255.0f},
								{  0.0f/255.0f, 128.0f/255.0f,  64.0f/255.0f},
								{  0.0f/255.0f,  64.0f/255.0f, 128.0f/255.0f},
								{128.0f/255.0f,   0.0f/255.0f, 128.0f/255.0f},
								{128.0f/255.0f, 128.0f/255.0f, 192.0f/255.0f},
								{  0.0f/255.0f, 128.0f/255.0f, 255.0f/255.0f},
								{128.0f/255.0f, 255.0f/255.0f, 128.0f/255.0f},
								{128.0f/255.0f,  64.0f/255.0f,  64.0f/255.0f},
								{128.0f/255.0f, 128.0f/255.0f,  64.0f/255.0f},
								{128.0f/255.0f,   0.0f/255.0f, 255.0f/255.0f},
								{128.0f/255.0f, 128.0f/255.0f, 255.0f/255.0f}};

	typedef void (__stdcall *GluQuadricCallbackType)();
	
	void _stdcall quadric_error_cb(int signal);

}


#endif